board = {}

empty = Image.load("empty.png")
red = Image.load("red.png")
blue = Image.load("blue.png")
title = Image.load("title.png")

boardWidth = 7
boardHeight = 6

for y=1,boardHeight do
	board[y] = {}
	for x=1,boardWidth do
		board[y][x] = empty
	end
end

cellWidth = 20
cellHeight = 20

function checkWin(color, x, y)
	return nil
end

function drop(color, column)
	for y=1, boardHeight do
		if board[y][column] == empty then
			if y == boardHeight then
				board[y][column] = color
				return column, y
			else
				if board[y + 1][column] ~= empty then
					board[y][column] = color
					return column, y
				end	
			end
		end
	end
end

function countPieces(x, y, dx, dy)
	local count = 0
	while true do
		x = x + dx
		y = y + dy
		if x < 1 or x > boardWidth then break end
		if y < 1 or y > boardHeight then break end
		if board[y][x] == player then
			count = count + 1
		else
			break
		end
	end
	return count
end

function hasCurrentPlayerWon(x0, y0)
	local directions = { { 1, -1 }, { 1, 0 }, { 1, 1 }, { 0, 1 } }
	for _, direction in directions do
		dx = direction[1]
		dy = direction[2]
		count = countPieces(x0, y0, dx, dy) + countPieces(x0, y0, -dx, -dy) + 1
		if count >= 4 then return true end
	end
	return false
end

column = 1
player = red

while true do
	screen:clear()
	screen:blit(100, 200, title)
	screen:blit(column * cellWidth, 0, player)
	for y=1,boardHeight do
		for x=1,boardWidth do
			piece = board[y][x]
			x0 = x * cellWidth
			y0 = y * cellHeight
			if piece ~= empty then screen:blit(x0, y0, empty) end
			screen:blit(x0, y0, board[y][x])
		end
	end
	if won then
		screen:print(20, 150, won .. " player has won", Color.new(255, 255, 255))
	else
		pad = Controls.read()
		if pad ~= oldPad then
			oldPad = pad
			if pad:cross() then
				x, y = drop(player, column)
				if x then
					if hasCurrentPlayerWon(x, y) then
						if player == red then
							won = "red"
						else
							won = "blue"
						end
					else
						if player == red then
							player = blue
						else
							player = red
						end
					end
				end 
			elseif pad:left() then
				column = column - 1
				if column < 1 then
					column = boardWidth
				end
			elseif pad:right() then
				column = column + 1
				if column > boardWidth then
					column = 1
				end
			end
		end
	end
	screen.waitVblankStart()
	screen.flip()
end
